import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Bubble here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Balloon extends Actor
{
    private GreenfootImage img;
    private Color newRBC;
    private int size, cycleColors;
    private boolean waveReverse = false;
    private int waveValue = 0;
    private Key myKey;
    private Visualizer myScreen;
    /**
     * Act - do whatever the Bubble wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Balloon()
    {
        img = new GreenfootImage(30,30);
        newRBC= getNewRBC();
        img.setColor(newRBC);
        img.fillOval(0,0,20,20);
        setImage(img);
        cycleColors = 0;
    }

    public Balloon(Key k, Visualizer screen)
    {
        cycleColors = 0;
        myKey = k;
        size = 300;
        img = new GreenfootImage(size,size);
        newRBC= getNewRBC();
        img.setColor(newRBC);
        img.fillOval(size - 1,size - 1,(int)(size * 0.5),size);
        setImage(img);
        myScreen = screen;
    }    

    public void act() 
    {
        setLocation(getX() + 2,size / 2);
        if (size > 30) size-= 5;
        else pop();
        //        scaleDown();
        updateImage();
    }    

    public void pop()
    {
        popScript();
        getWorld().removeObject(this);

    }

    public void wave()
    {
        if (waveReverse)
        {
            waveValue-= 4;
            if (waveValue < -20)
            {
                waveReverse = false;
            }

        }
        if (!waveReverse)
        {
            waveValue+= 4;
            if (waveValue > 20)
            {
                waveReverse = true;
            }
        }
        setLocation(myKey.getX() - waveValue, getY());
    }

    public void updateImage()
    {
        img.clear();
        img = new GreenfootImage(size*2,size*2);
        img.setColor(newRBC);
        img.fillOval(size - 1,size - 1,size,size);
        setImage(img);
    }
    public Color getNewRBC()
    {
        cycleColors = Greenfoot.getRandomNumber(3);
        if (cycleColors == 0) return new Color (200,0,0,200);
        if (cycleColors == 1) return new Color (0,200,0,200);
        if (cycleColors == 2) return new Color (255,255,0,200);
        else return null;
    }
    public void popScript()
    {
        int totalPops = 0;
        while (totalPops < 8)
        {
            getWorld().addObject(new Pops(40* totalPops,newRBC,myScreen ),
                                                                  getX() + img.getWidth() / 4,
                                                                 getY() + img.getHeight() / 4);
            totalPops++;
        }
        
    }
    public void scaleDown()
    {
        if (size > 15)
        {
            size = size - 10;
            img.scale(size,size);
        }
    }
}
