import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class KeyParticle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class KeyParticle extends Actor
{
    private boolean waveReverse = false;
    private int waveValue = Greenfoot.getRandomNumber(20);
    private boolean alphaFade = true;
    private boolean shrink = false;

    private int speed;
    private Visualizer screen;
    private Color particleColor;
    private Color newParticleColor;
    private Color bgShader;
    private GreenfootImage image1;
    private int colorDropoffPoint;
    private int colorRiseupPoint;
    private int colorChangeRate;
    private int size;
    private int waveCounter;
    private Key k;
    /**
     * Act - do whatever the KeyParticle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    public KeyParticle(int newSpeed, int width, int height, Color clr, Visualizer vis,Key key)
    {

        k = key;
        waveCounter = 0;
        colorRiseupPoint = 50;
        colorDropoffPoint = 10;
        colorChangeRate = 5;
        setRotation(270);
        screen = vis;
        speed = newSpeed;
        size = 1;
        particleColor = clr;
        image1 = new GreenfootImage(width, height);    
        image1.setColor(clr);
        image1.fillOval(getImage().getWidth() / 2 - (size / 2),
            getImage().getHeight() - (size / 2),size,size);            
        setImage(image1);

    }

    public void act() 
    {
        changeAlpha();       
        changeSize();
        updateParticleImage();
        drawColors();
        wave();
        move(speed);
        if (getY() <= 0)
        {
            getWorld().removeObject(this);

        }

    }    

    public void changeSize()
    {
        if (size > 5 && shrink)
        {
            size--;
            image1.clear();
            if (size <= 6)
            {
                shrink = false;
            }
        }
        if (size < 50 && !shrink)
        {
            size++;
            image1.clear();
            if (size >= 49)
            {
                shrink = true;

            }
        }

    }
    public void changeAlpha()
    {
        if (getImage().getColor().getAlpha() <= 249 && !alphaFade)
        {

            newParticleColor = new Color(particleColor.getRed(), 
                particleColor.getGreen(), 
                particleColor.getBlue(),
                particleColor.getAlpha() + 6);
            particleColor = newParticleColor;
            if  (particleColor.getAlpha() >= 248)
            {
                alphaFade = true;
            }
        }   
        if (getImage().getColor().getAlpha() >= 6 && alphaFade)
        {

            newParticleColor = new Color(particleColor.getRed(), 
                particleColor.getGreen(), 
                particleColor.getBlue(), 
                particleColor.getAlpha() - 6);
            particleColor = newParticleColor;
            if  (particleColor.getAlpha() < 7)
            {
                alphaFade = false;
            }
        }         
    }

    public void drawColors()
    {
        bgShader = new Color(particleColor.getRed(),
            particleColor.getGreen(),
            particleColor.getBlue(),
            5);
        screen.getImage().setColor(bgShader);
        screen.getImage().fillOval(getX()-size / 2,getY()-25,size,size);
    }

    public void updateParticleImage()
    {

        image1.setColor(particleColor);        
        image1.drawOval(25 - size / 2,
            25 -size / 2,
            size,
            size);
        image1.drawOval(24 - size / 2,
            24 -size / 2,
            size,
            size);
        image1.drawOval(23 - size / 2,
            23 -size / 2,
            size,
            size);


        setImage(image1);
    }

    public void wave()
    {
        if (waveReverse)
        {
            waveValue-= 4;
            if (waveValue < -20)
            {
                waveReverse = false;
            }

        }
        if (!waveReverse)
        {
            waveValue+= 4;
            if (waveValue > 20)
            {
                waveReverse = true;
            }
        }
        setLocation(k.getX() - waveValue, getY());
    }

}
